import { ProjectData } from "../../Shared/types";
import ts from "typescript";
export declare const ROACT_SYMBOL_NAMES: {
    Component: string;
    PureComponent: string;
    Fragment: string;
    Element: string;
};
export declare class RoactSymbolManager {
    private readonly symbols;
    private readonly jsxIntrinsicNameMap;
    private constructor();
    static create(data: ProjectData, program: ts.Program, typeChecker: ts.TypeChecker): RoactSymbolManager | undefined;
    getSymbolOrThrow(symbolName: string): ts.Symbol;
    getIntrinsicElementClassNameFromSymbol(symbol: ts.Symbol): string | undefined;
}
