"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.extendsRoactComponent = void 0;
const RoactSymbolManager_1 = require("../classes/RoactSymbolManager");
const getExtendsNode_1 = require("./getExtendsNode");
const getOriginalSymbolOfNode_1 = require("./getOriginalSymbolOfNode");
function extendsRoactComponent(state, node) {
    if (state.services.roactSymbolManager) {
        const extendsNode = (0, getExtendsNode_1.getExtendsNode)(node);
        if (extendsNode) {
            const symbol = (0, getOriginalSymbolOfNode_1.getOriginalSymbolOfNode)(state.typeChecker, extendsNode.expression);
            if (symbol) {
                return (symbol === state.services.roactSymbolManager.getSymbolOrThrow(RoactSymbolManager_1.ROACT_SYMBOL_NAMES.Component) ||
                    symbol === state.services.roactSymbolManager.getSymbolOrThrow(RoactSymbolManager_1.ROACT_SYMBOL_NAMES.PureComponent));
            }
        }
    }
    return false;
}
exports.extendsRoactComponent = extendsRoactComponent;
//# sourceMappingURL=extendsRoactComponent.js.map