"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getKeyAttributeInitializer = void 0;
const constants_1 = require("./constants");
const getAttributeName_1 = require("./getAttributeName");
const getAttributes_1 = require("./getAttributes");
const typescript_1 = __importDefault(require("typescript"));
function getKeyAttributeInitializer(element) {
    for (const attribute of (0, getAttributes_1.getAttributes)(element).properties) {
        if (typescript_1.default.isJsxAttribute(attribute) &&
            (0, getAttributeName_1.getAttributeNameText)(attribute.name) === constants_1.KEY_ATTRIBUTE_NAME &&
            attribute.initializer) {
            if (typescript_1.default.isStringLiteral(attribute.initializer)) {
                return attribute.initializer;
            }
            else if (typescript_1.default.isJsxExpression(attribute.initializer)) {
                return attribute.initializer.expression;
            }
        }
    }
}
exports.getKeyAttributeInitializer = getKeyAttributeInitializer;
//# sourceMappingURL=getKeyAttributeInitializer.js.map